{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Productos'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/product_list.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <script>
        $(document).ready(function () {
            //Selection

            var rules = {{rules|json_encode|raw}};

            var gridClient = $("#data-table-products").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: ""
                },
                selection: false,
                multiSelect: false,
                rowSelect: false,
                keepSelection: false,
                statusMappings: {
                    4: "bgm-bluegray",
                    5: "bgm-pink"
                },
                formatters: {
                    "commands": function (column, row) {
                        return "<button type=\"button\" class=\"btn btn-icon command-edit waves-effect waves-circle lo-e\" title=\"Editar marca\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-edit\"></span></button> " +
                                "<button type=\"button\" class=\"btn btn-icon command-delete waves-effect waves-circle lo-d\" title=\"Eliminar marca\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-delete\"></span></button>";
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {
                gridClient.find(".lo-e").on("click", function (e) {
                    //document.getElementById("create-product").reset();
                    $('#form-new-product').attr('data-action', 'put');
                    var id = $(this).data("id");

                    getProduct(id);

                    $('#modalDefault')
                      .find('.modal-title:first')
                      .text('Editar producto');
                    $('#modalDefault').modal('show');
                });

                gridClient.find(".lo-v").on("click", function (e) {
                    var id = $(this).data("-id");

                    //loadInfoClient(id);
                });

                gridClient.find(".lo-d").on("click", function (e) {
                    var id = $(this).data("id");

                    swal({
                        title: "¿Está seguro de eliminar el producto?",
                        text: "Se perderan todos los datos ingresados!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Borrar",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: true
                    }, function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: "DELETE",
                                url: '{{path_for('product-delete')}}',
                                data: {product_id: id},
                                dataType: "JSON",
                                success: function (data) {
                                    console.log(data);
                                    if (data.type > 1) {
                                        notify(data.message, 'success');
                                        setTimeout(function () {
                                            window.location.reload();
                                        }, 300);
                                    } else {
                                        notify(data.message, 'warning');
                                    }
                                },
                                error: function (data) {
                                    console.log(data);
                                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                                }
                            });
                        }
                    });
                });
            });

            //save
            $(document).on('click', '.save-product', function () {
                var type = $("#form-new-product").data('action');

                if (isCheckSave()) {
                    $.ajax({
                        type: type,
                        url: (type === 'put') ? '{{path_for('product-update')}}' : '{{path_for('product-create')}}',
                        data: $('#form-new-product').serializeArray(),
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            if (data.type > 1) {
                                notify(data.message, 'success');
                                setTimeout(function () {
                                    window.location.reload();
                                }, 300);
                            } else {
                                notify(data.message, 'warning');
                            }
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                        }
                    });
                } else {
                    $('#modal-msg').html('\
                        <div class="alert alert-warning alert-dismissible" role="alert">\n\
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n\
                                <span aria-hidden="true">×</span>\n\
                            </button>\n\
                            Completá los campos resaltados\n\
                        </div>'
                            ).show('slow');
                }
            });

            var getProduct = function (id) {
                $.ajax({
                    type: 'GET',
                    url: '{{path_for('product', {'id': id})}}' + id,
                    dataType: "JSON",
                    success: function (data) {
                        $('#brand_id').selectpicker('val', data.product.brand_id).trigger('change');
                        $('#product_id').val(id).trigger('change');
                        $('#identifier').val(data.product.identifier).trigger('change');
                        $('#product').val(data.product.product).trigger('change');
                        $('#type').val(data.product.type).trigger('change');
                        $('#item').val(data.product.item).trigger('change');
                        $('#sku').val(data.product.sku).trigger('change');
                        $('#description1').val(data.product.description1).trigger('change');
                        $('#description2').val(data.product.description2).trigger('change');
                        $('#price').val(data.product.price).trigger('change');
                        $('#category').val(data.product.category).trigger('change');
                        $('#upc_code').val(data.product.upc_code).trigger('change');
                        $('#fed').val(data.product.fed).trigger('change');
                        $('#gsa').val(data.product.gsa).trigger('change');
                        $('#coo').val(data.product.coo).trigger('change');
                        setTimeout(function(){
                          $('#family_select').val(data.product.family).trigger('change');
                        }, 1000);
                        $('.require-check').prop("checked", false);
                        $.each(data.rules, function(index, value){
                          $('#require-'+value.rules_key).prop("checked", true);
                        });
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, al intentar cargar los usuarios!', 'warning');
                    }
                });
            };
            //check form
            var isCheckSave = function () {
                var is = true;
                if ($('#brand_id').val() === '') {
                    $('#brand_id').next('.bootstrap-select').css({'border-bottom': '1px solid red'});
                    is = false;
                }

                if($('#type').val() === '') {
                  $('#type').next('.bootstrap-select').css({'border-bottom': '1px solid red'});
                  is = false;
                }

                if ($('#family_input').val() === '') {
                    $('#family_input').parents('.fg-line').addClass('has-error');
                    $('#family_select').next('.bootstrap-select').css({'border-bottom': '1px solid red'});
                    is = false;
                }

                if ($('#product').val() === '') {
                    $('#product').parents('.fg-line').addClass('has-error');
                    is = false;
                }

                if ($('#sku').val() === '') {
                    $('#sku').parents('.fg-line').addClass('has-error');
                    is = false;
                }

                if ($('#description1').val() === '') {
                    $('#description1').parents('.fg-line').addClass('has-error');
                    is = false;
                }

                return is;
            };

            $('#modalDefault').on('hidden.bs.modal', function () {
                $('.selectpicker').selectpicker('deselectAll');
                $('#product').parents('.fg-line').removeClass('has-error');
                $('#sku').parents('.fg-line').removeClass('has-error');

                $('#family_input').parents('.fg-line').removeClass('has-error');
                $('#description1').parents('.fg-line').removeClass('has-error');

                $('#brand_id').next('.bootstrap-select').css({'border-bottom': ''});
                $('#type').next('.bootstrap-select').css({'border-bottom': ''});

                $('.tab-nav li').removeClass('active');
                $('.tab-nav li:first').addClass('active');

                $('.tab-content .tab-pane').removeClass('active');
                $('.tab-content .tab-pane:first').addClass('active');

                $('input, textarea').val('').trigger('change');
            });

            $(document).on('click', '#create-product', function () {
                $('#form-new-product').attr('data-action', 'post');
                $('#modalDefault').find('.modal-title:first').text('Nuevo producto');

                $.each(rules, function(index, value){
                  $('#require-'+value.rules_key).prop("checked", (value.rules_value == "Y"));
                });
            });

            $(document).on('change', '#brand_id', function () {
                $('#brand_id').next('.bootstrap-select').css({'border-bottom': ''});
                $('#modal-msg').hide('slow');
                var uri = "{{path_for('product-family', {id: '%s1'})}}";

                $.get(uri.replace('%s1', $(this).val()), function( data ) {

                  $('#family_select').html('').trigger('change');

                  for (var i in data.family) {
                    if (!(data.family[i].family == "" ||  data.family[i].family === undefined)) {
                      $('#family_select').append("<option value='" + data.family[i].family + "'>" + data.family[i].family + "</option>");
                    }
                  }
                  $('#family_select').append("<option value='Otra'>Otra</option>");
                  $('#family_select').trigger('change');
                  $('.selectpicker').selectpicker('refresh');
                });
            });

            $(document).on('change', '#family_select', function () {
              $('#family_select').next('.bootstrap-select').css({'border-bottom': ''});
                var val = $(this).val();
                if(val === 'Otra') {
                  $('.action-hide').removeClass('hide');
                  $('#family_input').val();
                  $('*[data-id="family_select"]').addClass('hide');
                } else {
                  $('.action-hide').addClass('hide');
                  $('#family_input').val(val);
                  $('*[data-id="family_select"]').removeClass('hide');
                }
            });

            $(document).on('click', '.close-family', function(e){
              e.preventDefault();
              $('#family_input').val('');
              $('.action-hide').addClass('hide');
              $('#family_select').val('').trigger('change');
              $('*[data-id="family_select"]').removeClass('hide');
            });

            $(document).on('change', 'input, textarea', function(){
              if($(this).val() === '')
                $(this).parent().removeClass('fg-toggled');
              else
                $(this).parent().addClass('fg-toggled');
            });
        });
    </script>

{% endblock %}
